<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/BVH.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_b_v_h_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">BVH.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_b_v_h_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef BVH_h</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define BVH_h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_box_8hpp.html">Box.hpp</a>&quot;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_surface_8hpp.html">Surface.hpp</a>&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_ray_8hpp.html">Ray.hpp</a>&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="struct_b_v_h_flat_node.html">   11</a></span>&#160;<span class="keyword">struct </span><a class="code" href="struct_b_v_h_flat_node.html">BVHFlatNode</a> {</div><div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="struct_b_v_h_flat_node.html#a2eb8bc5ce9872472c56fbee34a921a87">   12</a></span>&#160;  <a class="code" href="class_box.html">Box</a> <a class="code" href="struct_b_v_h_flat_node.html#a2eb8bc5ce9872472c56fbee34a921a87">bbox</a>;</div><div class="line"><a name="l00013"></a><span class="lineno"><a class="line" href="struct_b_v_h_flat_node.html#a574e6ec522dfaf5ac6ed6263877c0358">   13</a></span>&#160;  uint32_t <a class="code" href="struct_b_v_h_flat_node.html#a574e6ec522dfaf5ac6ed6263877c0358">start</a>, <a class="code" href="struct_b_v_h_flat_node.html#a353b7a623510bace3e8e9e99acc1f382">nPrims</a>, <a class="code" href="struct_b_v_h_flat_node.html#afb4a21e37575d580a8f78e7e2aff1698">rightOffset</a>;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;};</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="class_b_v_h.html">   18</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_b_v_h.html">BVH</a> {</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;  uint32_t nNodes, nLeafs, leafSize;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;  std::vector&lt;Surface*&gt;* build_prims;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;  <span class="keywordtype">void</span> build();</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;  <span class="comment">// Fast Traversal System</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;  <a class="code" href="struct_b_v_h_flat_node.html">BVHFlatNode</a> *flatTree;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;  <span class="keyword">public</span>:</div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="class_b_v_h.html#ad8f1e5cdc88c248d3e94c6d3e5551a68">   29</a></span>&#160;  <a class="code" href="class_b_v_h.html#ad8f1e5cdc88c248d3e94c6d3e5551a68">BVH</a>() {};</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;  <a class="code" href="class_b_v_h.html">BVH</a>(std::vector&lt;Surface*&gt;* objects, uint32_t leafSize=4);</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;  <span class="keywordtype">bool</span> getIntersection(<span class="keyword">const</span> <a class="code" href="class_ray.html">Ray</a>&amp; ray, <a class="code" href="structhit__rec.html">hit_rec</a> *h_r, <span class="keywordtype">bool</span> occlusion)  ;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;  ~<a class="code" href="class_b_v_h.html">BVH</a>();</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;};</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="_ray_8hpp_html"><div class="ttname"><a href="_ray_8hpp.html">Ray.hpp</a></div></div>
<div class="ttc" id="class_b_v_h_html"><div class="ttname"><a href="class_b_v_h.html">BVH</a></div><div class="ttdef"><b>Definition:</b> BVH.h:18</div></div>
<div class="ttc" id="_box_8hpp_html"><div class="ttname"><a href="_box_8hpp.html">Box.hpp</a></div></div>
<div class="ttc" id="struct_b_v_h_flat_node_html_afb4a21e37575d580a8f78e7e2aff1698"><div class="ttname"><a href="struct_b_v_h_flat_node.html#afb4a21e37575d580a8f78e7e2aff1698">BVHFlatNode::rightOffset</a></div><div class="ttdeci">uint32_t rightOffset</div><div class="ttdef"><b>Definition:</b> BVH.h:13</div></div>
<div class="ttc" id="struct_b_v_h_flat_node_html_a574e6ec522dfaf5ac6ed6263877c0358"><div class="ttname"><a href="struct_b_v_h_flat_node.html#a574e6ec522dfaf5ac6ed6263877c0358">BVHFlatNode::start</a></div><div class="ttdeci">uint32_t start</div><div class="ttdef"><b>Definition:</b> BVH.h:13</div></div>
<div class="ttc" id="struct_b_v_h_flat_node_html"><div class="ttname"><a href="struct_b_v_h_flat_node.html">BVHFlatNode</a></div><div class="ttdoc">Node descriptor for the flattened tree. </div><div class="ttdef"><b>Definition:</b> BVH.h:11</div></div>
<div class="ttc" id="class_b_v_h_html_ad8f1e5cdc88c248d3e94c6d3e5551a68"><div class="ttname"><a href="class_b_v_h.html#ad8f1e5cdc88c248d3e94c6d3e5551a68">BVH::BVH</a></div><div class="ttdeci">BVH()</div><div class="ttdef"><b>Definition:</b> BVH.h:29</div></div>
<div class="ttc" id="class_box_html"><div class="ttname"><a href="class_box.html">Box</a></div><div class="ttdef"><b>Definition:</b> Box.hpp:12</div></div>
<div class="ttc" id="_surface_8hpp_html"><div class="ttname"><a href="_surface_8hpp.html">Surface.hpp</a></div></div>
<div class="ttc" id="struct_b_v_h_flat_node_html_a2eb8bc5ce9872472c56fbee34a921a87"><div class="ttname"><a href="struct_b_v_h_flat_node.html#a2eb8bc5ce9872472c56fbee34a921a87">BVHFlatNode::bbox</a></div><div class="ttdeci">Box bbox</div><div class="ttdef"><b>Definition:</b> BVH.h:12</div></div>
<div class="ttc" id="struct_b_v_h_flat_node_html_a353b7a623510bace3e8e9e99acc1f382"><div class="ttname"><a href="struct_b_v_h_flat_node.html#a353b7a623510bace3e8e9e99acc1f382">BVHFlatNode::nPrims</a></div><div class="ttdeci">uint32_t nPrims</div><div class="ttdef"><b>Definition:</b> BVH.h:13</div></div>
<div class="ttc" id="class_ray_html"><div class="ttname"><a href="class_ray.html">Ray</a></div><div class="ttdoc">A class to create and manipulate 3D rays. </div><div class="ttdef"><b>Definition:</b> Ray.hpp:12</div></div>
<div class="ttc" id="structhit__rec_html"><div class="ttname"><a href="structhit__rec.html">hit_rec</a></div><div class="ttdoc">A structure used to hold information regarding ray-surface intersection events. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:20</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_b_v_h_8h.html">BVH.h</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
